#!/bin/bash
#
# Generate WooCommerce Subscriptions stubs from the vendor directory.
#
# @note Must copy/paste woocommerce-subscriptions directory under vendor before running.
#       DO not include in GIT as is a premium plugin!
#
# Used via `%rootDir%/../../../stubs/woocommerce-subscriptions/woocommerce-subscriptions-3.0.php` under `scanFiles`.

PLUGIN_VERSION="3.0"

Get_legacy_files() {
    # Already in WC
    echo "vendor/woocommerce-subscriptions/includes/libraries/"
    # Legacy
    echo "vendor/woocommerce-subscriptions/includes/api/legacy"
    echo "vendor/woocommerce-subscriptions/includes/legacy"
}

# Delete class files
Get_legacy_files | xargs -- rm -v -r

vendor/bin/generate-stubs \
    --force \
    --header="//Stubs generated by \`../stub-generators/woocommerce-subscriptions.sh\`." \
    --functions \
    --classes \
    --interfaces \
    --traits \
    --out=stubs/woocommerce-subscriptions/woocommerce-subscriptions-${PLUGIN_VERSION}.php \
    ./vendor/woocommerce-subscriptions
